#! /bin/sh

echo "update.sh starting ..."

 #	name: 	 	upgrade_uimage 
 #	function:  if Image exist,then upgrade it
 #	parameter:	  
 #	author:		zhiwei 
 upgrade_uimage()
 {
	UIMAGE_FILE=$1
	MTDNUM=$2
	echo $UIMAGE_FILE" upgrade starting on "$MTDNUM
	if [ -f /usr/bin/siglent/usr/usr/upgrade/$UIMAGE_FILE ]; then
		echo "upgrade "$UIMAGE_FILE
		flash_erase /dev/$MTDNUM 0 0
		nandwrite -s 0 -p /dev/$MTDNUM /usr/bin/siglent/usr/usr/upgrade/$UIMAGE_FILE
	else
		echo $UIMAGE_FILE" no exist :not need upgrade"
	fi
	echo $UIMAGE_FILE" upgrade ending"
 }
#	name: 	 	upgrade_app 
#	function:  if uImage.img exist,then upgrade it
#	parameter:	  
#	author:		zhiwei 
 upgrade_app()
 {
	echo " app upgrade starting"
	if [ -f /usr/bin/siglent/usr/usr/upgrade/*.app ]; then
		cp -pf /usr/bin/siglent/usr/usr/upgrade/*.app /usr/bin/siglent/
	fi
	if [ -d /usr/bin/siglent/usr/usr/upgrade/ui_data ]; then
		cp -rpf /usr/bin/siglent/usr/usr/upgrade/ui_data /usr/bin/siglent/config/
	fi
	if [ -d /usr/bin/siglent/usr/usr/upgrade/drivers ]; then
		cp -rpf /usr/bin/siglent/usr/usr/upgrade/drivers/* /usr/bin/siglent/drivers/
	fi
	if [ -f /usr/bin/siglent/usr/usr/upgrade/top_sds1000b_fpga.bit ]; then
		cp -pf /usr/bin/siglent/usr/usr/upgrade/top_sds1000b_fpga.bit /usr/bin/siglent/config/fpga/
	fi
	if [ -f /usr/bin/siglent/usr/usr/upgrade/user_default_setting.xml ]; then
		cp -pf /usr/bin/siglent/usr/usr/upgrade/user_default_setting.xml /usr/bin/siglent/usr/usr/
	fi
	if [ -f /usr/bin/siglent/usr/usr/upgrade/NSP_config_upgrade_info.xml ]; then
		cp -pf /usr/bin/siglent/usr/usr/upgrade/NSP_config_upgrade_info.xml /usr/bin/siglent/config/
	fi
	if [ -d /usr/bin/siglent/usr/usr/upgrade/lib ]; then
		cp -rpf /usr/bin/siglent/usr/usr/upgrade/lib/* /usr/bin/siglent/lib
	fi
	if [ -d /usr/bin/siglent/usr/usr/upgrade/www ]; then
		cp -rpf /usr/bin/siglent/usr/usr/upgrade/www /usr/bin/siglent/config
	fi
	sync
	echo " app upgrade ending"
 }
 #	name: 	 	upgrade_cfg 
#	function:  upgrade cfg file for example *.xml and so on
#	parameter:	  
#	author:		zhiwei 
 upgrade_cfg()
 {
	echo " cfg upgrade starting"
	sync
	mount -o rw,remount /usr/bin/siglent/firmdata0
	sync
	if [ -f /usr/bin/siglent/usr/usr/upgrade/bandwidth.txt ]; then
		cp -pf /usr/bin/siglent/usr/usr/upgrade/bandwidth.txt /usr/bin/siglent/firmdata0
	fi
	if [ -f /usr/bin/siglent/usr/usr/upgrade/factory_setting.xml ]; then
		cp -pf /usr/bin/siglent/usr/usr/upgrade/factory_setting.xml /usr/bin/siglent/firmdata0
	fi
	if [ -f /usr/bin/siglent/usr/usr/upgrade/pro_filter_cfg.bin ]; then
		cp -pf /usr/bin/siglent/usr/usr/upgrade/pro_filter_cfg.bin /usr/bin/siglent/firmdata0
	fi
	sync
	mount -o ro,remount /usr/bin/siglent/firmdata0
	sync
	echo " cfg upgrade ending"
 }
#	name: 	 	mount_fs 
#	function:  upgrade cfg file for example *.xml and so on
#	parameter:	  
#	author:		zhiwei 
mount_fs()
{
	sync
	mount -o sync,$1,remount /usr/bin/siglent/
	sync
}

chmod -R 777 /usr/bin/siglent/usr/usr/upgrade/*
upgrade_uimage "BOOT.bin" "mtd0"
upgrade_uimage "uImage" "mtd1"
upgrade_uimage "devicetree.dtb" "mtd2"
upgrade_uimage "rootfs.cramfs" "mtd9"
#upgrade_uimage "firmdata0.img" "mtd6"
#upgrade_uimage "siglent.img" "mtd7"
#upgrade_uimage "datafs.img" "mtd8"

mount_fs rw
upgrade_app
mount_fs ro
upgrade_cfg
echo "update.sh ending ..."
